package cz.moneta.test.regression.commercial.smallbusiness.digital.localtests.banka.products.smeautomats.fop;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.ufo.banka.tasks.BankaTasks;
import cz.moneta.test.dsl.util.credentials.Keys;
import cz.moneta.test.dsl.util.data.client.*;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenario;
import cz.moneta.test.harness.support.auth.Credentials;
import cz.moneta.test.harness.support.auth.Key;
import cz.moneta.test.regression.commercial.smallbusiness.digital.DataPrepare;
import cz.moneta.test.regression.commercial.smallbusiness.digital.TearDown;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;

import static cz.moneta.test.harness.annotations.Environment.PPE;
import static cz.moneta.test.harness.annotations.Environment.TST1;

@TestScenario(name = "Create Green Expres Business")
public class CreateGreenExpresBusiness {

    private NonClient nonClient;
    private BankaTasks bankaTasks;

    @BeforeAll
    protected void setUp(Harness harness) {
        bankaTasks = harness.tasks().ufo().banka();
        nonClient = DataPrepare.setUpFop(harness);
    }

    @TestCase(name = "Create Green Expres Business", environments = {TST1, PPE})
    @JiraTestCase(id = "SBD-T452")
    public void createGreenExpresBusiness(Harness harness, @Key(Keys.ufo.banka.banker) Credentials credentials) {
        String dummyEmail = "dummy.a1a2a3a4a5a6a7a8@ge.com";
        String loanGreenAmount = "500000";
        String lastYear = DataPrepare.getLastYear();
        String yearBeforeLast = DataPrepare.getYearBeforeLast();

        harness.withUfo()
                .openLoginPage()
                .then(bankaTasks.login().withCredentialsAndTurnOffSignpad(credentials))
                .then(bankaTasks.search().findByIco(nonClient.ico()))
                .then(bankaTasks.sharedTasks().storeFullNameAndIco())
                .then(bankaTasks.newSmeAutomatFopTasks().withGreenExpresBusiness(harness, dummyEmail, loanGreenAmount, lastYear, yearBeforeLast));

    }

    @AfterEach
    protected void tearDown(Harness harness) {
        TearDown.storeIcoFullNameCifSessionId(harness);
    }
}